{
 "cells": [
  {
   "cell_type": "code",
   "execution_count": 1,
   "id": "a6a0684a-1d45-4dcc-9d1e-cd41e36712ba",
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/plain": [
       "7.5"
      ]
     },
     "execution_count": 1,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "# 1. Write a function to compute gas mileage, given distance and gas\n",
    "# test calling it with distance 15, gas 2\n",
    "\n",
    "def mileage(distance,gas):\n",
    "    return distance/gas\n",
    "\n",
    "mileage(15,2)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 2,
   "id": "7fc5b0d3-3179-4614-9726-fe887d91eb64",
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/plain": [
       "5.0"
      ]
     },
     "execution_count": 2,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "# 2. Write a function to compute speed, given distance and time\n",
    "# test calling it with distance 25, time 5\n",
    "\n",
    "def speed(distance,time):\n",
    "    return distance/time\n",
    "\n",
    "speed(25,5)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 3,
   "id": "d82e7936-84fc-433c-aa99-9d88901316b9",
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/plain": [
       "Trip - time:0:05:45, distance:14, gas:2"
      ]
     },
     "execution_count": 3,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "# 3. Write a class to hold the data for one trip. It should then store elapsed time, distance, and gas as fields. \n",
    "# It should also have a nice message when printed, giving time, distance, and gas.\n",
    "# Use the provided stub code at the end to test it\n",
    "import datetime as dt\n",
    "class Trip:\n",
    "    \n",
    "    # I set defaults here for all the values to make it easier later to create a \"zero-value\" trip for using sum()\n",
    "    def __init__(self,time=dt.timedelta(),distance=0,gas=0):\n",
    "        self.time = time\n",
    "        self.distance = distance\n",
    "        self.gas = gas\n",
    "        \n",
    "    def __repr__(self):\n",
    "        return f'Trip - time:{self.time}, distance:{self.distance}, gas:{self.gas}'\n",
    "\n",
    "    # additions from question #6 below\n",
    "    def __add__(self,other):\n",
    "        return Trip(\n",
    "            self.time + other.time,\n",
    "            self.distance + other.distance,\n",
    "            self.gas + other.gas\n",
    "        )\n",
    "    \n",
    "    def __truediv__(self,num):\n",
    "        #this will error if you try to divide by trip, but we don't need that here anyway\n",
    "        return Trip(\n",
    "            self.time / num,\n",
    "            self.distance / num,\n",
    "            self.gas / num\n",
    "        )\n",
    "\n",
    "\n",
    "trip = Trip(dt.timedelta(seconds=345),14,2) # <=== replace YourTripClass with your trip class name\n",
    "trip"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 4,
   "id": "63f0d488-8767-48bc-b72b-5b4acff1388f",
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/plain": [
       "Car 123 - number of trips: 1"
      ]
     },
     "execution_count": 4,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "# 4. Write another class to hold data for a car. init should take the car number which it will store as a field, and set up a list field to store trips\n",
    "# It should have a method to add a trip, and it will append it to the trips field\n",
    "# It should also have a nice message when printed, giving the car number and total number of trips\n",
    "# Use the provided stub code at the end to test it\n",
    "\n",
    "class Car:\n",
    "    \n",
    "    def __init__(self,carnum):\n",
    "        self.carnum = carnum\n",
    "        self.trips = []\n",
    "    \n",
    "    def addTrip(self,trip):\n",
    "        self.trips.append(trip)\n",
    "    \n",
    "    def __repr__(self):\n",
    "        return f'Car {self.carnum} - number of trips: {len(self.trips)}'\n",
    "        \n",
    "    # additions from question #7 below\n",
    "    def avgMileage(self):\n",
    "        # first compute the average trip\n",
    "        t = sum(self.trips,Trip()) / len(self.trips)\n",
    "        #then compute mileage\n",
    "        return mileage(t.distance,t.gas)\n",
    "    \n",
    "    def avgSpeed(self):\n",
    "        # same as above except compute speed\n",
    "        t = sum(self.trips,Trip()) / len(self.trips)\n",
    "        #then compute speed\n",
    "        return speed(t.distance,t.time.total_seconds()) * 3600\n",
    "    \n",
    "    # additions from question #8 below\n",
    "    def __gt__(self,other):\n",
    "        return self.avgMileage() > other.avgMileage()\n",
    "\n",
    "car = Car(123) # <=== replace YourCarClass with your car class name\n",
    "car.addTrip(trip)\n",
    "car"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 5,
   "id": "b545df5f-5b91-440e-9158-ef32942e893b",
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/plain": [
       "64"
      ]
     },
     "execution_count": 5,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "# 5. The following code will create a dictionary to store all the cars, read cardata.csv, and get all the values ready to put into your classes. \n",
    "# Complete the code where specified to use your classes to store all the data\n",
    "\n",
    "import datetime as dt\n",
    "import os\n",
    "\n",
    "cardata = {}\n",
    "fmt = '%H:%M:%S'\n",
    "with open('cardata.csv') as f:\n",
    "    for line in f.read().splitlines():\n",
    "        fields = line.split(',')\n",
    "        carnum,start,end,d,g = tuple(fields)\n",
    "        start = dt.datetime.strptime(start,fmt)\n",
    "        end = dt.datetime.strptime(end,fmt)\n",
    "        d = float(d)\n",
    "        g = float(g)\n",
    "        #using setdefault makes this work whether we've seen this car yet or not\n",
    "        car = cardata.setdefault(carnum,Car(carnum)) # <=== replace YourCarClass with a call to create an instance of your car class, using the carnum\n",
    "        #create an instance of your trip class here for your trip\n",
    "        trip = Trip(end-start,d,g)\n",
    "        #add the trip to the car here\n",
    "        car.addTrip(trip)\n",
    "len(cardata) # this will print out the length - should be 64"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 6,
   "id": "44090060-326b-427c-90ef-895137b64a19",
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "Trip1: Trip - time:0:50:23, distance:98.86362007964907, gas:4.842427198250858\n",
      "Trip2: Trip - time:1:48:15, distance:60.95221415017025, gas:10.008698693114866\n",
      "Total: Trip - time:2:38:38, distance:159.8158342298193, gas:14.851125891365724\n"
     ]
    }
   ],
   "source": [
    "# 6. Go back to your trip class above, and add methods so that we can add trips together, and divide trips by a number.\n",
    "# They should do the calculations on all the stored values.\n",
    "# The following code will try adding the first two trips of the first car, use it to test your changes above\n",
    "# HINT - if you make changes above, you need to rerun the cell for them to take effect. \n",
    "#        easiest way is to use \"restart kernel and run all\" button (looks like fast-forward)\n",
    "\n",
    "car = next(iter(cardata.values()))\n",
    "trip1 = car.trips[0]\n",
    "trip2 = car.trips[1]\n",
    "total = trip1 + trip2\n",
    "print(f'Trip1: {trip1}\\nTrip2: {trip2}\\nTotal: {total}')"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 7,
   "id": "41d2903e-7462-4c52-bf5c-2242f1beaa15",
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/plain": [
       "9.267838274062798"
      ]
     },
     "execution_count": 7,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "#7. Go back to your car class above, and add methods to compute the average mileage and speed of all the trips the car made\n",
    "# Use the following code to test your changes\n",
    "# HINTS - average is sum of trips / number of trips\n",
    "#       - if you try to use the built-in sum() function, remember to set initial value - see homework #6 from beginner class for an example\n",
    "#       - use the mileage and speed functions from questions 1 & 2\n",
    "\n",
    "car.avgMileage() # <=== replace YourMileageMethod here with your mileage method name"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 8,
   "id": "654a6b17-7122-47c7-86b3-89e42e31db78",
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "Car 26 had the best mileage of 16.501870966414536, and traveled 134.7101129800593 mph.\n"
     ]
    }
   ],
   "source": [
    "#8. Go back to your car class and add a method to compare cars. Have it use average mileage to do the comparison\n",
    "# The following code will print the car with the best mileage, and its speed. Use it to test your changes above\n",
    "# HINT - try running this code without changing your class and it will throw an error. use the error to determine which method you need to add\n",
    "\n",
    "bestcar = max(cardata.values())\n",
    "print(f'Car {bestcar.carnum} had the best mileage of {bestcar.avgMileage()}, and traveled {bestcar.avgSpeed()} mph.')"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "id": "f9efa1c9-ff5f-4fa8-bce5-5d9815abdde6",
   "metadata": {},
   "outputs": [],
   "source": []
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "Python 3 (ipykernel)",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.8.13"
  }
 },
 "nbformat": 4,
 "nbformat_minor": 5
}
